/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <errno.h>
#include <unistd.h>
#include <stddef.h>
#include <stdint.h>

void *sbrk(const intptr_t increment)
{
    const unsigned pagesize = 64 << 10;
    extern char __heap_base[];
    static char *cur = __heap_base, *end;

    if (increment < 0)
    {
        errno = EINVAL;
        return NULL;
    }
    else if (!end)
        end = cur + __builtin_wasm_memory_size(0) * pagesize;

    if (increment >= (intptr_t)end || cur >= end - increment)
    {
        const unsigned long pages = (uintptr_t)increment / pagesize,
            new_end = __builtin_wasm_memory_grow(0, pages);

        if (!new_end)
        {
            errno = ENOMEM;
            return NULL;
        }

        end = (void *)new_end;
    }

    void *ret = cur;

    cur += increment;
    return ret;
}
